// Accs  la carte 1208LS

//#define TEST

#include "windows.h"
#include "cbw.h"  

HANDLE MemHandle32;
unsigned short *ADValues;

// Lecture entre analogique
unsigned short readana(unsigned board,unsigned chanel,unsigned short *val)
{
return cbAIn(board, chanel, BIP10VOLTS, val);
}

// Ecriture entre analogique
unsigned short writeana(unsigned board,unsigned chanel,unsigned short val)
{
return cbAOut(board, chanel, 0, val);
}

// Lecture entre TOR
int readtor(unsigned board,unsigned chanel,unsigned short *val)
{
return cbDIn(board, chanel, val);
}

// Ecriture sortie TOR
int writetor(unsigned board,unsigned chanel,unsigned short val)
{
return cbDOut(board, chanel, val);
}

// Lecture conteur
int readcount(unsigned board,unsigned chanel,unsigned *val)
{
return cbCIn32(board,chanel, val);
}

// RAZ conteur
int resetcount(unsigned board,unsigned chanel)
{
return cbCClear (board,chanel);
}


// Initialisation carte et configuration port lecture ou criture
int init(unsigned board,unsigned porta,unsigned portb)
{
cbDConfigPort (board, 10, porta?DIGITALOUT:DIGITALIN);
cbDConfigPort (board, 11, portb?DIGITALOUT:DIGITALIN);
return 0;
}


void uninit(void)
{


}

#ifdef TEST
void main(void)
{
unsigned count;
init(0,1,0);
for(count=0;count<1000;count++)
	{
	unsigned cc;
	unsigned short v,v1,v2,v3,v4,v5;
	unsigned vc;
	int ret[100],i=0;
	ret[i++]=writetor(0,10,255);
	ret[i++]=readtor(0,11,&v);

	//ret[i++]=readcount(0,1,&vc);
	//ret[i++]=writeana(0,0,123);
	//ret[i++]=writeana(0,1,123);
	cprintf("%5u : %8.8X\r",count,v);
	}
}
#endif

