// Architecture de driver A7
// 26/07/2002 : premire version

#pragma pack(1)

#include "windows.h"
#include "commctrl.h"
#include "winbase.h"
#include "memory.h"
#include "stdio.h"
#include "stddef.h"
#include "resource.h"

#include "a7driver.h"
#include "1208ls.h"

// **********************************************************************************************
//					CES DECLARATIONS SONT OBLIGATOIRES
// **********************************************************************************************

#include "c:\automgen v7\a3a4a5a6\autom6\exedrv32\exec_drv.h"
#include "c:\automgen v7\a3a4a5a6\autom6\exedrv32\exedrv32.h"


// Ces variables globales sont la copie des paramtres reus de l'excuteur EXECPC_32

extern APP_CONTEXT *gpContext;	// Pointe sur les adresse de variables, leur nombre et les pointeurs de fonctions

extern char *gpFile_ini;		// Un pointeur sur le nom du fichier INI


// Ces variables globales sont renseignes par la librairie

extern HINSTANCE hInstance;				// Hinstance de la DLL reue de DllMain(DLL_PROCESS_ATTACH,...)

extern DWORD gdCurrentPseudoInstance;	// Numro "d'instance" du driver si plusieurs fois dans la liste

extern char szHelpFile[];				// Le nom complet du fichier d'aide se trouve ici


// **********************************************************************************************
//					FIN DES DECLARATIONS OBLIGATOIRES
// **********************************************************************************************

#define IDC_STATIC -1	// Evite l'appel de WinHelp sur le clique d'lments statiques


PRIVATE_DATA	gPrivateData[MAX_DLL_INSTANCE];		// Tableau de structures lies
													//  1 driver de ce type dans la liste


DWORD WINAPI threadproc(LPVOID lpParameter)
{
WORD *pw;
PRIVATE_DATA *pPrivateData=(PRIVATE_DATA *)lpParameter;
pPrivateData->bStop=FALSE;
pw=gpContext->adrvarm;
pPrivateData->taskcount=0;
init(pPrivateData->DrvNum,(pw[200+11*pPrivateData->DrvNum]&2)?1:0,(pw[200+11*pPrivateData->DrvNum]&4)?1:0);
do
	{
	//HDC hdc;
	unsigned count;
	//char z[1024];
	unsigned na;
	//hdc=CreateDC("DISPLAY",NULL,NULL,NULL);
	pPrivateData->reti=0;

	if((pw[200+11*pPrivateData->DrvNum]&2)==0)
		{
		if(readtor(pPrivateData->DrvNum,10,&pPrivateData->va)<0) pPrivateData->reti=-1;
		}
	if((pw[200+11*pPrivateData->DrvNum]&4)==0)
		{
		if(readtor(pPrivateData->DrvNum,11,&pPrivateData->vb)<0) pPrivateData->reti=-1;
		}
	//sprintf(z,"%u - %2.2X : %2.2X",pPrivateData->resetc,(unsigned char)pPrivateData->va,(unsigned char)pPrivateData->vb);
	//TextOut(hdc,0,0,z,strlen(z));
	//DeleteDC(hdc);
	
	if((pw[200+11*pPrivateData->DrvNum]&1)) na=4;
	else na=8;
	for(count=0;count<na;count++)
		{
		if(readana(pPrivateData->DrvNum,count,&pPrivateData->via[count])) pPrivateData->reti=-1;
		}
	if(readcount(pPrivateData->DrvNum,1,&pPrivateData->vc)) pPrivateData->reti=-1;
	if(pPrivateData->resetc) resetcount(pPrivateData->DrvNum,1);
	pPrivateData->reto=0;
	if((pw[200+11*pPrivateData->DrvNum]&2)!=0)
		{
		if(writetor(pPrivateData->DrvNum,10,pPrivateData->va)) pPrivateData->reto=-1;
		}
	if((pw[200+11*pPrivateData->DrvNum]&4)!=0)
		{
		if(writetor(pPrivateData->DrvNum,11,pPrivateData->vb)) pPrivateData->reto=-1;
		}
	if(writeana(pPrivateData->DrvNum,0,pPrivateData->voa[0])) pPrivateData->reto=-1;
	if(writeana(pPrivateData->DrvNum,1,pPrivateData->voa[1])) pPrivateData->reto=-1;
	pPrivateData->taskcount++;
	}
while(!pPrivateData->bStop);
pPrivateData->bStop=FALSE;
return 0;
}


// Code  excuter pour initialiser des E/S
// En retour 0, si driber initialis, -1 si erreur (affichage du message d'erreur  la charge du driver dans ce cas)
int drv_init(PRIVATE_DATA *pPrivateData)
{
WORD *pw;
DWORD id;
unsigned count;
pPrivateData->reti=0;
pPrivateData->reto=0;
pPrivateData->va=0;
pPrivateData->vb=0;
pPrivateData->vc=0;
pPrivateData->resetc=0;
for(count=0;count<8;count++)
	{
	pPrivateData->via[count]=0;
	}
for(count=0;count<4;count++)
	{
	pPrivateData->voa[count]=0;
	}
pPrivateData->thread=CreateThread(NULL,0,threadproc,(LPVOID)pPrivateData,0,&id);
if(pPrivateData->thread==NULL)
	{
	return -1;
	}
pPrivateData->fDriverEnable = TRUE;
pw=gpContext->adrvarm;
//init(pPrivateData->DrvNum,(pw[200+11*pPrivateData->DrvNum]&2)?1:0,(pw[200+11*pPrivateData->DrvNum]&4)?1:0);
return 0;
}

// Code  excuter pour d-initialiser des E/S
int drv_uninit(PRIVATE_DATA *pPrivateData)
{
if(pPrivateData->thread)
	{
	DWORD dwCurTime=GetTickCount();
	pPrivateData->bStop=TRUE;
	do
		{
		Sleep(50);
		if(GetTickCount()-dwCurTime>5000) // 5 secondes pour terminer normalement
			{ // Autrement tuer le thread
			TerminateThread(pPrivateData->thread,0);
			CloseHandle(pPrivateData->thread);
			return 0;
			}
		}
	while(pPrivateData->bStop);
	}
return 0;
}

// Code  excuter pour forcer des E/S  0
int drv_reset(PRIVATE_DATA *pPrivateData)
{
int ret=0;
unsigned count;
DWORD dw;
pPrivateData->va=0;
pPrivateData->vb=0;
for(count=0;count<4;count++)
	{
	pPrivateData->voa[count]=0;
	}
pPrivateData->taskcount=0;
dw=GetTickCount();
while(pPrivateData->taskcount<2&&GetTickCount()-dw<2000)
	{
	Sleep(10);
	}
return ret;
}


// Pour valider un eventuel watch dog sur le systme d'E/S
int drv_watchdog(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Code  excuter pour lire les entres
int drv_input(PRIVATE_DATA *pPrivateData)
{
BYTE *pI;
WORD *pW;
DWORD *pDW;
unsigned count;
if(pPrivateData->fDriverEnable == FALSE)
	{
	return 0;
	}
if(pPrivateData->taskcount<2) // Attendre que la tche d'accs aux I/Os fonctionne
	{
	return 0;
	}
pI=gpContext->adrvari;
pW=gpContext->adrvarm;
pDW=gpContext->adrvarl;
pI+=pPrivateData->DrvNum*16;
pW+=pPrivateData->DrvNum*11;

if((pW[200]&2)==0)
	{
	for(count=0;count<8;count++)
		{
		#ifdef _1208FS
		gpContext->ptr_in1var(pI,(unsigned char)((pPrivateData->va&(1<<count))?1:0));
		#else
		gpContext->ptr_in1var(pI,(unsigned char)((pPrivateData->va&(1<<count))?0:1));
		#endif
		pI++;
		}
	}
if((pW[200]&4)==0)
	{
	for(count=0;count<8;count++)
		{
		#ifdef _1208FS
		gpContext->ptr_in1var(pI,(unsigned char)((pPrivateData->vb&(1<<count))?1:0));
		#else
		gpContext->ptr_in1var(pI,(unsigned char)((pPrivateData->vb&(1<<count))?0:1));
		#endif
		pI++;
		}
	}
for(count=0;count<8;count++)
	{
	pW[203+count]=pPrivateData->via[count];
	}
pDW[pPrivateData->DrvNum]=pPrivateData->vc;
return pPrivateData->reti;
}


// Code  excuter pour crire des sorties
int drv_output(PRIVATE_DATA *pPrivateData)
{
BYTE *pO;
WORD *pW;
unsigned short v=0;
int ret=0;
unsigned count;
if(pPrivateData->fDriverEnable == FALSE)
	{
	return 0;
	}
pO=gpContext->adrvaro;
pW=gpContext->adrvarm;
pO+=pPrivateData->DrvNum*16;
pW+=pPrivateData->DrvNum*11;
if((pW[200]&2)!=0)
	{
	for(count=0;count<8;count++)
		{
		#ifdef _1208FS
		if((pO[count]&0x40)==0)
		#else
		if(pO[count]&0x40)
		#endif
			{
			v|=(1<<count);
			}
		}
	pPrivateData->va=v^255;
	pO+=8;
	}
v=0;
if((pW[200]&4)!=0)
	{
	for(count=0;count<8;count++)
		{
		#ifdef _1208FS
		if((pO[count]&0x40)==0)
		#else
		if(pO[count]&0x40)
		#endif
			{
			v|=(1<<count);
			}
		}
	pPrivateData->vb=v^255;
	}
pPrivateData->voa[0]=pW[201];
pPrivateData->voa[1]=pW[202];
pPrivateData->resetc=(pW[200]&8)?1:0;
return pPrivateData->reto;
}


// Code  excuter pour acqurir des entres en mode asynchrone
int drv_rin(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Code  excuter pour crire des sorties en mode asynchrone
int drv_wou(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Cette fonction est appele lors de l'ajout d'un driver dans la liste, juste aprs 
// le LoadLibrary pour allouer de la mmoire (si ncessaire)  un nouveau driver et 
// pour la documenter
int drv_create(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Code  excuter pour lire le .INI, allouer de la mmoire et la documenter
int drv_build(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Sauvegarde le paramtrage dans un fichier .INI
int drv_save(PRIVATE_DATA *pPrivateData)
{
return 0;
}



// Le driver se supprime les allocations faites par DRV_BUILD et/ou DRV_CREATE
int drv_destroy(PRIVATE_DATA *pPrivateData)
{
return 0;
}


// Code  excuter pour configurer le driver
// HWND, pointeur sur 3 exemplaires PRIVATE_DATA et le titre de la bote  onglets
int drv_config(HWND hwnd,LPARAM lparam,DWORD NumDrv)
{
return 0;
}
  

// Retourne une structure ncessaire  la partie commune des drivers
void *drv_PrivateDataInfo(INFO_PRIVATEDATA *gInfo_privatedata)
{
// Le nom "X.HLP" se retrouvera sous la forme dans "c:\automv6\X.HLP" szHelFile
gInfo_privatedata->pszHelFileName = HELP_FILE;
// Taille d'une structure de donnes globale
gInfo_privatedata->wPrivateDataSize = sizeof(PRIVATE_DATA);
// Nombre de postes de la tables de structures
gInfo_privatedata->wMaxPseudoInstance = MAX_DLL_INSTANCE;
// Donne  la librairie l'offset du poste DrvNum dans la structure PRIVATE_DATA
gInfo_privatedata->wOffsetDrvNum = offsetof(PRIVATE_DATA,DrvNum);
// Donne  la librairie l'adresse de la table des structures de donnes globales
return (void *)gPrivateData;
}

